commit 06c8a6ac79559472370b97432908fbb210900dfb
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Wed Oct 30 15:08:55 2024 +0530

    PS-9434 A stored procedure often causes "mysqld got exception 0xc0000005" error
    
    https://perconadev.atlassian.net/browse/PS-9434
    
    Bug#36492114 mysql/mysql-server@0f8002cf6ae
    
     Description:
     ------------
     A stored procedure often causes MySQL to stop with a
     "mysqld got exception 0xc0000005" error. This occurs while applying
     join order hints. The stored procedure has been executed continuously
     several thousand times, with the same error occurring approximately
     once every 2,000 executions. After removing the QB_NAME hint from
     the procedure, the issue no longer occurred.
    
     Analysis:
     ------------
     Based on the analysis, the issue occurs only with stored procedures
     that include a `SELECT` query with `QB_NAME` and `JOIN_*` hints.
     The failure happens when hint's `query_block_name` and `Table_ref`'s
     `query_block_name` are compared in `set_join_hint_deps()`.
    
     In `db_load_routine()`, the stored procedure definition
     string (`String defstr`) is created and passed to the parser as
     an input buffer.
     The parser creates a `PT_qb_level_hint` object with a `Hint_param_table`
     (which holds the `table_name` and `query_block_name`) and then pushes it
     to the `join_order_hints` list.
     Since `defstr` is created as a local variable, when `db_load_routine()`
     goes out of scope, `defstr` is destroyed. However,
     `Hint_param_table::opt_query_block` is still pointing to the `defstr`
     location.
     Later, while executing `apply_join_order_hints()`, `compare_table_name()`
     tries to access `hint_table->opt_query_block`, leading to
     a heap-use-after-free error.
    
     It appears that the issue lies with the lexical scanner for hint comments.
     The token pointer for `query_block_name` is not allocated as a string
     outside of the input buffer(`defstr`).
     The hint parser uses `Hint_scanner::scan_query_block_name()` to scan
     the query block name from hint comments.
     In `scan_query_block_name()`, if the token doesn't contain backquotes
     or double quotes, it simply returns the current token pointer, pointing
     to the input buffer.
     This heap-use-after-free error is easily visible with Asan, hard to reproduce
     with normal build.
    
     Fix:
     ----
     Ensure the token pointer of `query_block_name` to point to a string
     allocated outside of the lex input buffer.
     This approach is similar to how the query block name is handled when
     using backquotes and double quotes.
    
    Change-Id: Ib9b117529c27955add4ac722ce2b2c1b56dad462

diff --git a/sql/sql_lex_hints.h b/sql/sql_lex_hints.h
index 21f3ea9855d..319a61804d9 100644
--- a/sql/sql_lex_hints.h
+++ b/sql/sql_lex_hints.h
@@ -1,5 +1,5 @@
 /*
-   Copyright (c) 2014, 2023, Oracle and/or its affiliates.
+   Copyright (c) 2014, 2024, Oracle and/or its affiliates.
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2.0,
@@ -259,7 +259,11 @@ protected:
     case HINT_CHR_IDENT:
     case HINT_CHR_DIGIT:
     case HINT_CHR_MB:
-      return scan_ident() == HINT_ARG_IDENT ? HINT_ARG_QB_NAME : HINT_ERROR;
+      if (scan_ident() == HINT_ARG_IDENT) {
+        yytext = thd->strmake(yytext, yyleng);
+        return HINT_ARG_QB_NAME;
+      } else
+        return HINT_ERROR;
     case HINT_CHR_BACKQUOTE:
       return scan_quoted_ident<HINT_CHR_BACKQUOTE>() == HINT_ARG_IDENT ?
           HINT_ARG_QB_NAME : HINT_ERROR;

